// 
//
#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <string.h>
#include <iostream.h>

#include "Server.h"
#include "Password.h"
#include "File.h"

strstream authorization;
int maxdepth = 1;

void usage( void )
{
   printf("Usage:  web_mirror  http://<www.x.y>/<url>  [-p user:passwd]  [-s /dir]  [-d <depth>]\n");

   exit(1);
}

int main( int argc, char *argv[] )
{
    char c;
    int depth = 1;
    char *save = strdup("/tmp/");
    Password *passwd = 0;           // ("collections","tmywindow");

    if ( argc < 2 ) usage();

    URL *rootURL = new URL(argv[1]); 
/*    while ((c = getopt(argc, argv, "d:s:p:")) != -1) {
       switch (c) {
          case 'd':
             maxdepth = atoi( optarg );
             break;
          case 'p':
             passwd = new Password( optarg );
             break;
          case 's':
             save = strdup( optarg );
             break;
          case '?':
             usage();
       }
    }
*/

	for (int i=2; i<argc; i++) 
		if (argv[i][0] == '-') {
			switch(argv[i][1]) {
				case 'd':
					maxdepth = atoi( argv[i+1] );
					i++;
					break;
				case 'p':
					passwd = new Password( argv[i+1] );
					break;
				case 's':
		             save = strdup( argv[i+1] );
					break;
				case '?':
		             usage();
			}
			i++;
		}



    Server::SetCurrentServer( rootURL->Host() );
    Server::SetCurrentPort( rootURL->Port() );
    File rootFile( rootURL );

    rootFile.Retrieve( maxdepth, save, passwd );

    return 1;
}
